using System;

namespace Interfaces
{
	/// <summary>
	/// The entry point for everything
	/// </summary>
	class CUniverse
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			//The bosses are born
			CBoss bill = new CBoss("Bill", "Gates", DateTime.Parse("12.07.1962"));
			CBoss gisella = new CBoss("Gisella", "Rader", DateTime.Parse("24.07.1971"));
			//The worker is born
			CWorker michael = new CWorker ("Michael", "Rader", DateTime.Parse("18.12.1969"));
			//The worker's dog is born
			CDog hasso = new CDog("Hasso", "Yorkshire Terrier");
			//bill wants to get notified about michaels work progress
			michael.RegisterNotification(bill); 
			//gisella wants to get notified about michaels work progress
			michael.RegisterNotification(gisella); 
			//hasso wants to get notified about michaels work progress
			michael.RegisterNotification(hasso); 
//			//Optional alternative: Get an interface reference before calling the method
//			INotifyable hassoNotifyableInterface = (INotifyable)hasso;
//			michael.RegisterNotification(hassoNotifyableInterface); 
//			//Optional alternative: Another way to get an interface reference before calling the method
//			INotifyable hassoNotifyableInterface= new CDog ("Hasso","Yorkshire Terrier") as INotifyable;
//			michael.RegisterNotification(hassoNotifyableInterface); 
			michael.StartWork(); //Michael starts working
			//The evolution finishes here an the universe goes to sleep
			System.Threading.Thread.Sleep(TimeSpan.FromSeconds(200)); 
		}
	}
}
